// (c) 2014, SAS Institute Inc.

sap.ui.define(['jquery.sap.global', 'sap/ui/core/Core',
    "sap/ui/core/library", // library dependency
    "sas/hc/ui/commons/library", // library dependency
    "sas/hc/m/library" // library dependency
],
    function(jQuery) {
        "use strict";

        /**
         * @namespace
         * @name sas.hc.ui.services.navigation
         * @public
         */

        /**
         * @namespace
         * @name sas.hc.ui.services.navigation.classes
         * @public
         */

        /**
         * @namespace
         * @name sas.hc.ui.services.navigation.config
         * @public
         */

        /**
         * @namespace
         * @name sas.hc.ui.services.navigation.descriptors
         * @public
         */

        // delegate further initialization of this library to the Core
        sap.ui.getCore().initLibrary({
            name : "sas.hc.ui.services.navigation",
            dependencies : ["sap.ui.core","sas.hc.ui.commons","sas.hc.m","sas.ltjs.sasicu"],
            types : [
            ],
            interfaces : [
            ],
            controls : [
                "sas.hc.ui.services.navigation.ContentDataDescriptor",
                "sas.hc.ui.services.navigation.ContentNavigationModel",
                "sas.hc.ui.services.navigation.ContentSelectionPane-A11y",
                "sas.hc.ui.services.navigation.ContentSelectionPane",
                "sas.hc.ui.services.navigation.ContentSelector",
                "sas.hc.ui.services.navigation.ContentTypeDescriptor",
                "sas.hc.ui.services.navigation.classes.ContentColumnView",
                "sas.hc.ui.services.navigation.classes.ContentSelectorD",
                "sas.hc.ui.services.navigation.classes.ContentSelectorM",
                "sas.hc.ui.services.navigation.classes.NavigatorToolBar",
                "sas.hc.ui.services.navigation.config.ContentItemIdentity",
                "sas.hc.ui.services.navigation.config.FilteredItemsConfig",
                "sas.hc.ui.services.navigation.config.FilterItem",
                "sas.hc.ui.services.navigation.config.ModelConfig",
                "sas.hc.ui.services.navigation.config.ServiceConfig",
                "sas.hc.ui.services.navigation.controls.NavigationListItem",
                "sas.hc.ui.services.navigation.descriptors.ContentPermissionsDescriptor",
                "sas.hc.ui.services.navigation.descriptors.ContentPETDataDescriptor",
                "sas.hc.ui.services.navigation.descriptors.ContentPETPermissionsDescriptor",
                "sas.hc.ui.services.navigation.descriptors.ContentPETTypeDescriptor",
                "sas.hc.ui.services.navigation.descriptors.ContentPETValidationResultDescriptor",
                "sas.hc.ui.services.navigation.descriptors.ContentValidationResultDescriptor",
                "sas.hc.ui.services.navigation.descriptors.OperationsResultDescriptor",
                "sas.hc.ui.services.navigation.descriptors.PETOperationsResultDescriptor",
                "sas.hc.ui.services.navigation.models.ContentNavigationPETModel",
                "sas.hc.ui.services.navigation.types.DataIntegrationObjectTypeConstants",
                "sas.hc.ui.services.navigation.types.ObjectTypeConstants",

                "sas.hc.ui.services.navigation.util.CNUtil",
                "sas.hc.ui.services.navigation.util.FilterUtil",
                "sas.hc.ui.services.navigation.util.ItemMenuHelper",
                "sas.hc.ui.services.navigation.util.ItemUtil",
                "sas.hc.ui.services.navigation.util.ListUtil",
                "sas.hc.ui.services.navigation.util.PetServicesUtil",
                "sas.hc.ui.services.navigation.util.SASFoldersSvcUtil",
                "sas.hc.ui.services.navigation.util.ServiceConfigUtil",
                "sas.hc.ui.services.navigation.util.SortUtil"

            ],
            elements : [
            ],
            version : "904001.6.0.20231016105100_f0htmcm94p"});

        return sas.hc.ui.services.navigation;
    }
);