// (c) 2014, SAS Institute Inc.

sap.ui.define(['jquery.sap.global', 'sap/ui/core/Core'
],
    function(jQuery) {
        "use strict";

        /**
         * @namespace
         * @name sas.hc.ui.services.search
         * @public
         */

        /**
         * @namespace
         * @name sas.hc.ui.services.search.controls
         * @public
         */

        // delegate further initialization of this library to the Core
        sap.ui.getCore().initLibrary({
            name : "sas.hc.ui.services.search",
            dependencies : ["sas.hc.m", "sas.hc.ui.services.navigation"],
            types : [
            ],
            interfaces : [
            ],
            controls : [
                "sas.hc.ui.services.search.ApplicationAndTypeAccessUtil",
                "sas.hc.ui.services.search.CincoSearchField",
                "sas.hc.ui.services.search.CincoSearchPanel",
                "sas.hc.ui.services.search.SearchResSorter",
                "sas.hc.ui.services.search.SearchResultListItem",
                "sas.hc.ui.services.search.controls.ResultHeader",
                "sas.hc.ui.services.search.controls.ResultList",
                "sas.hc.ui.services.search.controls.ResultListItem",
                "sas.hc.ui.services.search.controls.ResultSortMenu",
                "sas.hc.ui.services.search.service.ApplicationAndTypeAccessService",
                "sas.hc.ui.services.search.service.ContentTypeService",
                "sas.hc.ui.services.search.service.DefaultApplicationAndTypeAccessServiceImpl",
                "sas.hc.ui.services.search.service.DefaultContentTypeServiceImpl",
                "sas.hc.ui.services.search.service.DefaultPETApplicationAndTypeAccessServiceImpl",
                "sas.hc.ui.services.search.service.DefaultPETContentTypeServiceImpl",
                "sas.hc.ui.services.search.service.DefaultPETSchemaServiceImpl",
                "sas.hc.ui.services.search.service.DefaultPETSearchServiceImpl",
                "sas.hc.ui.services.search.service.DefaultSchemaServiceImpl",
                "sas.hc.ui.services.search.service.DefaultSearchServiceImpl",
                "sas.hc.ui.services.search.service.SchemaService",
                "sas.hc.ui.services.search.service.SearchService",
                "sas.hc.ui.services.search.serviceProxy.SchemaServiceProxy",
                "sas.hc.ui.services.search.serviceProxy.SearchServiceProxy",
                "sas.hc.ui.services.search.views.ResultView",
                "sas.hc.ui.services.search.views.helper.FacetHelper"
            ],
            elements : [
            ],
            version : "904001.6.0.20231016105100_f0htmcm94p"});

        //Used by Search Schema Service to indicate MaxMinFields in schema fields.
        sas.hc.ui.services.search.schema = {
            "NUMERIC_DATA" : {
                "CONTIGUOUS" : "CONTIGUOUS"
            }
        };

        return sas.hc.ui.services.search;
    }
);